library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;

entity top_level is

Port (led					: out std_logic_vector(3 downto 0);
		btn					: in std_logic_vector(1 downto 0);
		io_j3					: in std_logic_vector(17 downto 0);
		io_j4					: in std_logic_vector(17 downto 0);
		clk					: in std_logic);
end top_level;

architecture Behavioral of top_level is

signal count: 		std_logic_vector(20 downto 0);
signal count2: 	std_logic_vector(1 downto 0);
signal i_o:			std_logic_vector(35 downto 0);
signal io_sum: 	std_logic_vector(5 downto 0);
signal btns,ok:	std_logic;

begin
	
	process(clk)
	begin
		if clk'event and clk = '1' then
			count <= count + '1';
		end if;
	end process;
	
process(btn)
begin
  if (btn(0) = '0') then
      btns <= '0';
  elsif (btn(1) = '0') then
		btns <= '1';
  end if;
end process;

	process(count(20))
	begin
		if count(20)'event and count(20) = '1' then
		if (btns='0')		then count2 <= count2 + '1';
		elsif (btns='1')	then count2 <= count2 - '1';
		end if;
		end if;
	end process;

process(clk,count2,ok)
begin
if (ok='1') then led <= (others => '1');
elsif (clk'event and clk='1') then
   case count2 is 
      when "00" => led <= "0001";
		when "01" => led <= "0010";
		when "10" => led <= "0100";
		when "11" => led <= "1000";
      when others => led <= "0000";
   end case;
	end if;
end process;

i_o <= io_j3&io_j4;

io_sum <= 
("00000"&i_o(	0	))
+("00000"&i_o(	1	))
+("00000"&i_o(	2	))
+("00000"&i_o(	3	))
+("00000"&i_o(	4	))
+("00000"&i_o(	5	))
+("00000"&i_o(	6	))
+("00000"&i_o(	7	))
+("00000"&i_o(	8	))
+("00000"&i_o(	9	))
+("00000"&i_o(	10	))
+("00000"&i_o(	11	))
+("00000"&i_o(	12	))
+("00000"&i_o(	13	))
+("00000"&i_o(	14	))
+("00000"&i_o(	15	))
+("00000"&i_o(	16	))
+("00000"&i_o(	17	))
+("00000"&i_o(	18	))
+("00000"&i_o(	19	))
+("00000"&i_o(	20	))
+("00000"&i_o(	21	))
+("00000"&i_o(	22	))
+("00000"&i_o(	23	))
+("00000"&i_o(	24	))
+("00000"&i_o(	25	))
+("00000"&i_o(	26	))
+("00000"&i_o(	27	))
+("00000"&i_o(	28	))
+("00000"&i_o(	29	))
+("00000"&i_o(	30	))
+("00000"&i_o(	31	))
+("00000"&i_o(	32	))
+("00000"&i_o(	33	))
+("00000"&i_o(	34	))
+("00000"&i_o(	35	));

ok <= '1' WHEN io_sum = "100011" ELSE '0';

end Behavioral;